  .inesprg 1
  .ineschr 1
  .inesmap 0
  .inesmir 1

  .bank 0
  .org $C000 

RESET:
  SEI         
  CLD         
  LDX #$40
  STX $4017   
  LDX #$FF
  TXS         
  INX         
  STX $2000   
  STX $2001   
  STX $4010   

vblankwait1:  
  BIT $2002
  BPL vblankwait1

clrmem:
  LDA #$00
  STA $0000, x
  STA $0100, x
  STA $0200, x
  STA $0400, x
  STA $0500, x
  STA $0600, x
  STA $0700, x
  LDA #$FE
  STA $0300, x
  INX
  BNE clrmem
   
vblankwait2:  
  BIT $2002
  BPL vblankwait2


LoadPalettes:
  LDA $2002  
  LDA #$3F
  STA $2006  
  LDA #$00
  STA $2006  
  LDX #$00   
LoadPalettesLoop:
  LDA palette, x

  STA $2007             
  INX                   
  CPX #$20              
  BNE LoadPalettesLoop  

LoadSprites:
  LDX #$00              

LoadSpritesLoop:
  LDA sprites, x        
  STA $0200, x          
  INX                   
  CPX #$20              
  BNE LoadSpritesLoop   
              
  LDA #%10001000
  STA $2000

  LDA #%00010000 
  STA $2001

Forever:
  JMP Forever     

NMI:
  LDA #$00
  STA $2003       
  LDA #$02
  STA $4014       


  LDA $0020
  CMP #$03
  BEQ SettingGameGlobalVariablesDone

  LDA #$FF
  STA $0102 

  LDA #$D0
  STA $0090 

  LDA #$60
  STA $0091 

  LDA #$20
  STA $0111 

  LDA $0090
  STA $0112 

  LDA #$20
  STA $0113

  LDA #$E0
  STA $0114 

  LDA #$7F
  STA $0115 

  LDA #$7F
  STA $0116 

  LDA #$00
  STA $0030

  LDA #$00
  STA $0110

  LDA #$00
  STA $0100

  LDA #$01
  STA $0101

  LDA #%10010000
  STA $2001

  LDA #$03
  STA $0020 

SettingGameGlobalVariablesDone:

  LDX $0100
  INX
  STX $0100

  LDA $0100
  CMP $0102
  BNE TimerDone 

  LDA #$00
  STA $0100 

  LDA $0101  
  CMP #$01          
  BEQ ChangeTurnTo2 

  LDA #$01         
  STA $0101        

  LDA #%10010000   
  STA $2001

  JMP TimerDone

ChangeTurnTo2:

  LDA #$02         
  STA $0101        

  LDA #%01010000   
  STA $2001        

TimerDone:

  LDA $0040
  CMP #$03
  BEQ SettingPlayer1VariablesDone

  LDA #$04
  STA $0041

  LDA #$00
  STA $0051 

  LDA #$03
  STA $0040 
SettingPlayer1VariablesDone:
 
  LDA $0092
  CMP #$03
  BEQ P1OnFloor 

  LDA $0093
  CMP #$03
  BEQ P1NotOnFloorGoingUp 

  JMP P1Falling

P1NotOnFloorGoingUp:
  JMP P1Jumping
            
P1OnFloor:
  
  LDA $0093
  CMP #$03
  BEQ P1OnFloorGoingUp 

  JMP P1Walking 

P1OnFloorGoingUp:
  JMP P1JustJumped 

P1Falling:
  LDA $0200
  CLC      
  ADC #$02 
  STA $0200

  JMP P1GravityCycleDone

P1Jumping:

  JMP P1GravityCycleDone

P1Walking:

  JMP P1GravityCycleDone 

P1JustJumped:
  LDA $0200
  CLC      
  SBC #$02 
  STA $0200

  JMP P1GravityCycleDone

P1GravityCycleDone:

  LDA $0200
  CMP $0091
  BCC P1MaximumHeightReached  

  LDA $0200                 
  CMP $0090                 
  BCS P1FloorReached        

  JMP P1PlayerRefreshDone

P1MaximumHeightReached:
  LDA #$00
  STA $0092     

  LDA #$00
  STA $0093     

  JMP P1PlayerRefreshDone

P1FloorReached:
  LDA #$03
  STA $0092    

  LDA #$00
  STA $0093    

  JMP P1PlayerRefreshDone

P1PlayerRefreshDone:

  LDA $0043
  CMP #$03
  BEQ SettingPlayer2VariablesDone

  LDA #$04
  STA $0042

  LDA #$00
  STA $0052

  LDA #$03
  STA $0043
SettingPlayer2VariablesDone:
 
  LDA $0094
  CMP #$03
  BEQ P2OnFloor 

  LDA $0095
  CMP #$03
  BEQ P2NotOnFloorGoingUp 

  JMP P2Falling


P2NotOnFloorGoingUp:
  JMP P2Jumping 

           
P2OnFloor:
  
  LDA $0095
  CMP #$03
  BEQ P2OnFloorGoingUp  

  JMP P2Walking 

P2OnFloorGoingUp:
  JMP P2JustJumped 

P2Falling:
  LDA $0208       
  CLC             
  ADC #$02        
  STA $0208       

  JMP P2GravityCycleDone

P2Jumping:
  JMP P2GravityCycleDone

P2Walking:
  JMP P2GravityCycleDone 

P2JustJumped:
  LDA $0208
  CLC      
  SBC #$02 
  STA $0208

  JMP P2GravityCycleDone

P2GravityCycleDone:

  LDA $0208                 
  CMP $0091                 
  BCC P2MaximumHeightReached

  LDA $0208                 
  CMP $0090                 
  BCS P2FloorReached        

  JMP P2PlayerRefreshDone

P2MaximumHeightReached:
  LDA #$00
  STA $0094     

  LDA #$00
  STA $0095     

  JMP P2PlayerRefreshDone

P2FloorReached:
  LDA #$03
  STA $0094     

  LDA #$00
  STA $0095     

  JMP P2PlayerRefreshDone

P2PlayerRefreshDone:

  LDA $0054
  CMP #$03
  BEQ SettingBallVariablesDone

  LDA #$07  
  STA $0082 

  LDA #$7F  
  STA $0080 

  LDA #$7F  
  STA $0081 

  LDA #$03
  STA $0050 

  LDA #$03
  STA $0055 

  LDA #$03
  STA $0054 
SettingBallVariablesDone:

  LDA $0051
  CMP #$03
  BEQ Player1HasBall

  LDA $0052
  CMP #$03
  BEQ Player2HasBall

  LDA $0050
  CMP #$04
  BEQ BallReleasedToRight

  LDA $0050
  CMP #$05
  BEQ BallReleasedToLeft

  JMP BallPositionChangingDone

Player1HasBall:
  
  LDA $0200  
  SBC #$05
  STA $0204  
  
  LDA $0203  
  STA $0207  

  LDA $0041  
  STA $0050  

  JMP BallPositionChangingDone

Player2HasBall:
  
  LDA $0208  
  SBC #$05
  STA $0204  
  
  LDA $020B  
  STA $0207  

  LDA $0042  
  STA $0050  

  JMP BallPositionChangingDone

BallReleasedToRight:

  LDA $0204       
  CLC             
  ADC #$01        
  STA $0204       

  LDA $0207       
  CLC             
  ADC #$03        
  STA $0207       

  JMP BallPositionChangingDone

BallReleasedToLeft:

  LDA $0204
  CLC      
  ADC #$01 
  STA $0204

  LDA $0207       
  CLC             
  SBC #$03        
  STA $0207       

  JMP BallPositionChangingDone

BallPositionChangingDone:

  LDA $0204
  STA $0081

  LDA $0207
  STA $0080

  LDA $0204
  CLC
  ADC #$02 
  CMP $0090
  BCC BallUpdateStatusDone

  LDA #$03  
  STA $0050 

BallUpdateStatusDone:


CheckCollisionOn:
  LDA $0055                 
  CMP #$03                  
  BNE CheckCollisionOnDone  

  LDA $0203
  SBC $0080 
  CMP $0082 
  BCS CheckCollisionOnDone

  LDA $0200
  SBC $0081 
  CMP $0082 
  BCS CheckCollisionOnDone

  LDA #$03  
  STA $0051 

  LDA #$00  
  STA $0055 

CheckCollisionOnDone:

  LDA $0203
  SBC $0080
  CMP $0082
  BCS SetCheckCollisionOff


  LDA $0200
  SBC $0081
  CMP $0082
  BCS SetCheckCollisionOff

  JMP CheckCollisionOffDone

SetCheckCollisionOff:

  LDA #$03  
  STA $0055 

CheckCollisionOffDone:


P2CheckCollisionOn:
  LDA $0055                 
  CMP #$03                  
  BNE P2CheckCollisionOnDone

  LDA $020B
  SBC $0080
  CMP $0082
  BCS P2CheckCollisionOnDone


  LDA $0208
  SBC $0081
  CMP $0082
  BCS P2CheckCollisionOnDone

  LDA #$03 
  STA $0052

  LDA #$00 
  STA $0055

P2CheckCollisionOnDone:

  LDA $020B
  SBC $0080
  CMP $0082
  BCS P2SetCheckCollisionOff

  LDA $020B
  SBC $0081
  CMP $0082
  BCS P2SetCheckCollisionOff

  JMP P2CheckCollisionOffDone

P2SetCheckCollisionOff:

  LDA #$03 
  STA $0055

P2CheckCollisionOffDone:

LatchController:
  LDA #$01
  STA $4016
  LDA #$00
  STA $4016


ReadA:
  LDA $4016
  AND #%00000001  
  BEQ ReadADone  
    
  LDA $0092
  CMP #$03     
  BNE ReadADone

  LDA #$03    
  STA $0093   

ReadADone:    


ReadB:
  LDA $4016      
  AND #%00000001 
  BEQ ReadBDone  

  LDA $0051
  CMP #$03     
  BNE ReadBDone

  LDA #$00    
  STA $0051 

ReadBDone:


ReadStart:
  LDA $4016 
  AND #%00000001
  BEQ ReadStartDone

ReadStartDone:     

ReadSelect:
  LDA $4016       
  AND #%00000001  
  BEQ ReadSelectDone

  LDA #$00  
  STA $0020 
  STA $0054 
  STA $0040 
  STA $0043 

ReadSelectDone:

ReadUp: 
  LDA $4016    
  AND #%00000001
  BEQ ReadUpDone

ReadUpDone:        

ReadDown: 
  LDA $4016      
  AND #%00000001 
  BEQ ReadDownDone

ReadDownDone:

ReadLeft: 
  LDA $4016  
  AND #%00000001 
  BEQ ReadLeftDone

  LDA $0203       
  CLC             
  SBC #$01        
  STA $0203       

  LDA #$05
  STA $0041

ReadLeftDone:     
  

ReadRight: 
  LDA $4016       
  AND #%00000001  
  BEQ ReadRightDone

  LDA $0203
  CLC      
  ADC #$02 
  STA $0203


  LDA #$04
  STA $0041

ReadRightDone:

P2ReadA:
  LDA $4017
  AND #%00000001  
  BEQ P2ReadADone 
    
  LDA $0094
  CMP #$03   
  BNE P2ReadADone

  LDA #$03    
  STA $0095   

P2ReadADone:


P2ReadB:
  LDA $4017 
  AND #%00000001
  BEQ P2ReadBDone

  LDA $0052
  CMP #$03     
  BNE P2ReadBDone

  LDA #$00    
  STA $0052   

P2ReadBDone:       

P2ReadStart:
  LDA $4017              
  AND #%00000001         
  BEQ P2ReadStartDone    

P2ReadStartDone:       

P2ReadSelect:
  LDA $4017       
  AND #%00000001  
  BEQ P2ReadSelectDone  

  LDA #$00
  STA $0020 
  STA $0054 
  STA $0040 
  STA $0043 

P2ReadSelectDone:

P2ReadUp: 
  LDA $4017      
  AND #%00000001 
  BEQ P2ReadUpDone 

P2ReadUpDone:
  

P2ReadDown: 
  LDA $4017  
  AND #%00000001 
  BEQ P2ReadDownDone

P2ReadDownDone:   

P2ReadLeft: 
  LDA $4017       
  AND #%00000001  
  BEQ P2ReadLeftDone
 
  LDA $020B       
  CLC             
  SBC #$01        
  STA $020B       

  LDA #$05
  STA $0042

P2ReadLeftDone:
  

P2ReadRight: 
  LDA $4017       
  AND #%00000001  
  BEQ P2ReadRightDone

  LDA $020B
  CLC      
  ADC #$02 
  STA $020B

  LDA #$04
  STA $0042

P2ReadRightDone:    

  LDA $0101
  CMP #$01  
  BEQ P1GameOverCheckDone

  LDA $0051         
  CMP #$03  
  BNE P1GameOverCheckDone

  LDA #$01
  STA $0110 
P1GameOverCheckDone:

  LDA $0101
  CMP #$02 
  BEQ P2GameOverCheckDone

  LDA $0052         
  CMP #$03 
  BNE P2GameOverCheckDone

  LDA #$02
  STA $0110
P2GameOverCheckDone:


  LDA $0110
  CMP #$01   
  BEQ P1Lose

  LDA $0110
  CMP #$02
  BEQ P2Lose  

  JMP GameOverScreenDone 

P1Lose:
  LDA $0112
  STA $0200      

  LDA $0111
  STA $0208      

  JMP GameOverCommonDrawings
P2Lose:
  LDA $0112
  STA $0208      

  LDA $0111
  STA $0200      

GameOverCommonDrawings:

  LDA $0113
  STA $0203      

  LDA $0114
  STA $020B      

  LDA $0115
  STA $0207      

  LDA $0116
  STA $0204      

  LDA #%00010001
  STA $2001

GameOverScreenDone:

  RTI
  
  .bank 1
  .org $E000

palette:
  .db $0F,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$0F
  .db $0F,$1C,$15,$14,$31,$02,$38,$3C,$0F,$1C,$15,$14,$31,$02,$38,$3C

sprites:

  .db $A0, $25, $00, $20 

  .db $7F, $CF, $00, $7F 

  .db $A0, $24, $00, $E0 


  .org $FFFA   
  .dw NMI      

  .dw RESET 

  .dw 0
  
  .bank 2
  .org $0000

  .incbin "hunt_run.chr"